#!/bin/sh
# Bootstrap the CLucene installation.
# Run this to generate all the initial makefiles, etc.
srcdir=`dirname $0`
test -z "$srcdir" && srcdir=.

ORIGDIR=`pwd`
cd $srcdir
PROJECT=clucene-bindings
TEST_TYPE=-f
FILE=clucene.i

DIE=0

#create the temp gcc config dir
mkdir config 2>/dev/null

(autoconf --version) < /dev/null > /dev/null 2>&1 || {
	echo
	echo "You must have autoconf installed to compile $PROJECT."
	echo "Download the appropriate package for your distribution,"
	echo "or get the source tarball at ftp://ftp.gnu.org/pub/gnu/"
	DIE=1
}

AUTOMAKE=automake-1.9
ACLOCAL=aclocal-1.9

($AUTOMAKE --version) < /dev/null > /dev/null 2>&1 || {
     AUTOMAKE=automake
     ACLOCAL=aclocal
}

($AUTOMAKE --version) < /dev/null > /dev/null 2>&1 || {
	echo
	echo "You must have automake installed to compile $PROJECT."
	echo "Get ftp://sourceware.cygnus.com/pub/automake/automake-1.4.tar.gz"
	echo "(or a newer version if it is available)"
	DIE=1
}

(libtool --version) < /dev/null > /dev/null 2>&1 || {
    echo
    echo "**Error**: You must have \`libtool' installed to compile $PROJECT."
    echo "Get ftp://ftp.gnu.org/pub/gnu/libtool-1.2d.tar.gz"
    echo "(or a newer version if it is available)"
    DIE=1
}

if test "$DIE" -eq 1; then
	exit 1
fi

test $TEST_TYPE $FILE || {
	echo "You must run this script in the top-level $PROJECT directory"
	exit 1
}

if test "$1" = "--clean" || test "$1" = "--clear"; then
  make maintainer-clean
  
  #clean main directory
  rm -fdr libltdl config autom4te.cache build
  
  #clean csharp directory
  rm -fdr csharp/obj
  
  rm -fdr COM/gen
  
  exit 0
fi

set -x
libtoolize --force --copy --ltdl --automake
$ACLOCAL -I m4
autoconf
autoheader
$AUTOMAKE -a --copy

cd "$ORIGDIR"
