%{
	#include "CLucene/analysis/AnalysisHeader.h"
	#include "CLucene/analysis/Analyzers.h"
%}

////////////////////////////////////////////////////////////////////////////////
//AnalysisHeader.h
////////////////////////////////////////////////////////////////////////////////
%nodefault lucene::analysis::TokenStream;
%ignore lucene::analysis::TokenStream::next(Token* token); //todo: decide on this
%ignore lucene::analysis::Token::Token(); //todo: decide on this
%ignore lucene::analysis::Token::setEndOffset; //todo: decide on this
%ignore lucene::analysis::Token::setStartOffset; //todo: decide on this
%ignore lucene::analysis::Token::setType; //todo: decide on this
%ignore lucene::analysis::Token::set; //todo: decide on this
%ignore lucene::analysis::Token::bufferLength; //todo: decide on this
%ignore lucene::analysis::Token::growBuffer; //todo: decide on this
%ignore lucene::analysis::Token::termTextLength; //todo: decide on this
%ignore lucene::analysis::Token::resetTermTextLen; //todo: decide on this
%newobject lucene::analysis::TokenStream::next;

#ifdef SWIGCAP_NOOVERLOADING
	%ignore lucene::analysis::Token::Token(const TCHAR* text, const int32_t start, const int32_t end);
#endif

////////////////////////////////////////////////////////////////////////////////
//Analyzers.h
////////////////////////////////////////////////////////////////////////////////
%nodefault lucene::analysis::Analyzer;
%newobject lucene::analysis::Analyzer::tokenStream;
%ignore lucene::analysis::StopAnalyzer::ENGLISH_STOP_WORDS;
%ignore lucene::analysis::WhitespaceTokenizer;
%ignore lucene::analysis::LetterTokenizer;
%ignore lucene::analysis::LowerCaseTokenizer;
%ignore lucene::analysis::LowerCaseFilter;
%ignore lucene::analysis::StopFilter;
%ignore lucene::analysis::CharTokenizer;
%ignore lucene::analysis::LowerCaseFilter;
%ignore lucene::analysis::PorterStemmerFilter;
%ignore lucene::analysis::TokenFilter;
%ignore lucene::analysis::Tokenizer;

////////////////////////////////////////////////////////////////////////////////
//StandardAnalyzer.h
////////////////////////////////////////////////////////////////////////////////
//...

////////////////////////////////////////////////////////////////////////////////
//now include local definition
%include "local_analysis.i"

//now include the clucene headers
%include "CLucene/analysis/AnalysisHeader.h"
%include "CLucene/analysis/Analyzers.h"
%include "CLucene/analysis/standard/StandardAnalyzer.h"
