/*
* this is a monolithic file that can be used to compile clucene tests using one source file.
* 
* note: when creating a project add either this file, or all the other .cpp files, not both!
*/

#include "CuTest.cpp"
#include "testall.cpp"

#include "analysis/TestAnalysis.cpp"
#include "analysis/TestAnalyzers.cpp"
#include "index/TestHighFreqTerms.cpp"
#include "index/TestIndexWriter.cpp"
#include "index/TestReuters.cpp"
#include "index/TestUtf8.cpp"
#include "util/TestPriorityQueue.cpp"
#include "util/English.cpp"
#include "debug/TestError.cpp"
#include "queryParser/TestQueryParser.cpp"
#include "search/TestSearch.cpp"
#include "search/TestSort.cpp"
#include "search/TestTermVector.cpp"
#include "search/TestForDuplicates.cpp"
#include "search/TestDateFilter.cpp"
#include "search/TestWildcard.cpp"
#include "store/TestStore.cpp"

#ifdef TEST_SNOWBALL
   #include "analysis/TestSnowball.cpp"
#endif
#ifdef TEST_HIGHLIGHTER
   #include "search/TestHighlight.cpp"
#endif
